<html>
<head>
<title>OGRE: Ogre::VertexDeclaration Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a></div>
<h1>Ogre::VertexDeclaration Class Reference</h1><!-- doxytag: class="Ogre::VertexDeclaration" -->This class declares the format of a set of vertex inputs, which can be issued to the rendering API through a <a class="el" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreHardwareVertexBuffer_8h-source.html">OgreHardwareVertexBuffer.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1VertexDeclaration-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::list<br>
&lt; <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#60080b97acb5b645bf3524152d75cc5d">VertexElementList</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Defines the list of vertex elements that makes up this declaration.  <a href="#60080b97acb5b645bf3524152d75cc5d"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#564fde701486b259f4f995a799adb433">VertexDeclaration</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Standard constructor, not you should use <a class="el" href="classOgre_1_1HardwareBufferManager.html#0d6a29a55a89d937cec4cbaa6c7e8b4b" title="Creates a new vertex declaration.">HardwareBufferManager::createVertexDeclaration</a>.  <a href="#564fde701486b259f4f995a799adb433"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#27c14f93e37659aa583f572ba250b155">~VertexDeclaration</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#49ab5d499d097fd1e82d26b5bec35600">getElementCount</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the number of elements in the declaration.  <a href="#49ab5d499d097fd1e82d26b5bec35600"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="classOgre_1_1VertexDeclaration.html#60080b97acb5b645bf3524152d75cc5d">VertexElementList</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#a9e3bde080e00f7cb9ee737259bb7fa2">getElements</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets read-only access to the list of vertex elements.  <a href="#a9e3bde080e00f7cb9ee737259bb7fa2"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#bc1f33f288750dbd42074ba7861614c7">getElement</a> (unsigned short index)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get a single element.  <a href="#bc1f33f288750dbd42074ba7861614c7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#98cce285a45ba6f4cf817dcf46bfb588">sort</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sorts the elements in this list to be compatible with the maximum number of rendering APIs / graphics cards.  <a href="#98cce285a45ba6f4cf817dcf46bfb588"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#260ecb704cfc32b82f248e382a53be47">closeGapsInSource</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove any gaps in the source buffer list used by this declaration.  <a href="#260ecb704cfc32b82f248e382a53be47"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#da106dad90a32452cead050b2f1f76aa">getAutoOrganisedDeclaration</a> (bool skeletalAnimation, bool vertexAnimation)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Generates a new <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to...">VertexDeclaration</a> for optimal usage based on the current vertex declaration, which can be used with <a class="el" href="classOgre_1_1VertexData.html#a5bf979b80f8bf95d76b7b8c34ac6fce" title="Reorganises the data in the vertex buffers according to the new vertex declaration...">VertexData::reorganiseBuffers</a> later if you wish, or simply used as a template.  <a href="#da106dad90a32452cead050b2f1f76aa"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned short&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#2aca53e4f9ccb1cef8d070b037e3b649">getMaxSource</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the indeex of the highest source value referenced by this declaration.  <a href="#2aca53e4f9ccb1cef8d070b037e3b649"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const <br>
<a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#e789acf4f4a63d8638fc23cb4e26239f">addElement</a> (unsigned short source, size_t offset, <a class="el" href="namespaceOgre.html#027109503a988ba85f4c63b55082907f">VertexElementType</a> theType, <a class="el" href="namespaceOgre.html#0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> semantic, unsigned short index=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Adds a new <a class="el" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete...">VertexElement</a> to this declaration.  <a href="#e789acf4f4a63d8638fc23cb4e26239f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const <br>
<a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#b11e10c594cd765a0d8389b9e96ec24e">insertElement</a> (unsigned short atPosition, unsigned short source, size_t offset, <a class="el" href="namespaceOgre.html#027109503a988ba85f4c63b55082907f">VertexElementType</a> theType, <a class="el" href="namespaceOgre.html#0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> semantic, unsigned short index=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Inserts a new <a class="el" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete...">VertexElement</a> at a given position in this declaration.  <a href="#b11e10c594cd765a0d8389b9e96ec24e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#2dc6358fb76e454d7ae30da4d014687c">removeElement</a> (unsigned short elem_index)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove the element at the given index from this declaration.  <a href="#2dc6358fb76e454d7ae30da4d014687c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#d98b8d55cf8490d788ba46633143ef94">removeElement</a> (<a class="el" href="namespaceOgre.html#0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> semantic, unsigned short index=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove the element with the given semantic and usage index.  <a href="#d98b8d55cf8490d788ba46633143ef94"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#9c6df3f800c43118c49e30940445669f">removeAllElements</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove all elements.  <a href="#9c6df3f800c43118c49e30940445669f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#cf877a67096cf85fce47757010b531b1">modifyElement</a> (unsigned short elem_index, unsigned short source, size_t offset, <a class="el" href="namespaceOgre.html#027109503a988ba85f4c63b55082907f">VertexElementType</a> theType, <a class="el" href="namespaceOgre.html#0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> semantic, unsigned short index=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Modify an element in-place, params as addElement.  <a href="#cf877a67096cf85fce47757010b531b1"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const <br>
<a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#dcc074b1bc6cdad3bde1d44c84ec6ccb">findElementBySemantic</a> (<a class="el" href="namespaceOgre.html#0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> sem, unsigned short index=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Finds a <a class="el" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete...">VertexElement</a> with the given semantic, and index if there is more than one element with the same semantic.  <a href="#dcc074b1bc6cdad3bde1d44c84ec6ccb"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="classOgre_1_1VertexDeclaration.html#60080b97acb5b645bf3524152d75cc5d">VertexElementList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#8efa1381b62ed44af9e1e366938a455f">findElementsBySource</a> (unsigned short source)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Based on the current elements, gets the size of the vertex for a given buffer source.  <a href="#8efa1381b62ed44af9e1e366938a455f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#383736c1eed33634e0eaa9910f0176af">getVertexSize</a> (unsigned short source)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the vertex size defined by this declaration for a given source.  <a href="#383736c1eed33634e0eaa9910f0176af"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <br>
<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#933bb27a39695a561959638bfa82177c">clone</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Clones this declaration.  <a href="#933bb27a39695a561959638bfa82177c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#ee364dc39b2dfdbff4a5b135e5e5ef39">operator==</a> (const <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> &amp;rhs) const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#64989816c9979aac5a5416d488d547d5">operator!=</a> (const <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> &amp;rhs) const </td></tr>

<tr><td colspan="2"><br><h2>Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#670466fe9bcfc426ccefb5395a3a82ef">vertexElementLess</a> (const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &amp;e1, const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &amp;e2)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sort routine for vertex elements.  <a href="#670466fe9bcfc426ccefb5395a3a82ef"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexDeclaration.html#60080b97acb5b645bf3524152d75cc5d">VertexElementList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#dc48aa31318d2384866eab90ee8406d5">mElementList</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This class declares the format of a set of vertex inputs, which can be issued to the rendering API through a <a class="el" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>You should be aware that the ordering and structure of the <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to...">VertexDeclaration</a> can be very important on DirectX with older cards,so if you want to maintain maximum compatibility with all render systems and all cards you should be careful to follow these rules:<ol>
<li>
VertexElements should be added in the following order, and the order of the elements within a shared buffer should be as follows: position, blending weights, normals, diffuse colours, specular colours, texture coordinates (in order, with no gaps) </li>
<li>
You must not have unused gaps in your buffers which are not referenced by any <a class="el" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete...">VertexElement</a> </li>
<li>
You must not cause the buffer &amp; offset settings of 2 VertexElements to overlap </li>
</ol>
Whilst GL and more modern graphics cards in D3D will allow you to defy these rules, sticking to them will ensure that your buffers have the maximum compatibility. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>Like the other classes in this functional area, these declarations should be created and destroyed using the <a class="el" href="classOgre_1_1HardwareBufferManager.html" title="Abstract singleton class for managing hardware buffers, a concrete instance of this...">HardwareBufferManager</a>. </dd></dl>

<p>Definition at line <a class="el" href="OgreHardwareVertexBuffer_8h-source.html#l00291">291</a> of file <a class="el" href="OgreHardwareVertexBuffer_8h-source.html">OgreHardwareVertexBuffer.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="60080b97acb5b645bf3524152d75cc5d"></a><!-- doxytag: member="Ogre::VertexDeclaration::VertexElementList" ref="60080b97acb5b645bf3524152d75cc5d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::list&lt;<a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a>&gt; <a class="el" href="classOgre_1_1VertexDeclaration.html#60080b97acb5b645bf3524152d75cc5d">Ogre::VertexDeclaration::VertexElementList</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Defines the list of vertex elements that makes up this declaration. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareVertexBuffer_8h-source.html#l00295">295</a> of file <a class="el" href="OgreHardwareVertexBuffer_8h-source.html">OgreHardwareVertexBuffer.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="564fde701486b259f4f995a799adb433"></a><!-- doxytag: member="Ogre::VertexDeclaration::VertexDeclaration" ref="564fde701486b259f4f995a799adb433" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::VertexDeclaration::VertexDeclaration           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Standard constructor, not you should use <a class="el" href="classOgre_1_1HardwareBufferManager.html#0d6a29a55a89d937cec4cbaa6c7e8b4b" title="Creates a new vertex declaration.">HardwareBufferManager::createVertexDeclaration</a>. 
<p>

</div>
</div><p>
<a class="anchor" name="27c14f93e37659aa583f572ba250b155"></a><!-- doxytag: member="Ogre::VertexDeclaration::~VertexDeclaration" ref="27c14f93e37659aa583f572ba250b155" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::VertexDeclaration::~VertexDeclaration           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="670466fe9bcfc426ccefb5395a3a82ef"></a><!-- doxytag: member="Ogre::VertexDeclaration::vertexElementLess" ref="670466fe9bcfc426ccefb5395a3a82ef" args="(const VertexElement &amp;e1, const VertexElement &amp;e2)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static bool Ogre::VertexDeclaration::vertexElementLess           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>e1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>e2</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sort routine for vertex elements. 
<p>

</div>
</div><p>
<a class="anchor" name="49ab5d499d097fd1e82d26b5bec35600"></a><!-- doxytag: member="Ogre::VertexDeclaration::getElementCount" ref="49ab5d499d097fd1e82d26b5bec35600" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::VertexDeclaration::getElementCount           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the number of elements in the declaration. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareVertexBuffer_8h-source.html#l00306">306</a> of file <a class="el" href="OgreHardwareVertexBuffer_8h-source.html">OgreHardwareVertexBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="a9e3bde080e00f7cb9ee737259bb7fa2"></a><!-- doxytag: member="Ogre::VertexDeclaration::getElements" ref="a9e3bde080e00f7cb9ee737259bb7fa2" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1VertexDeclaration.html#60080b97acb5b645bf3524152d75cc5d">VertexElementList</a>&amp; Ogre::VertexDeclaration::getElements           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets read-only access to the list of vertex elements. 
<p>

</div>
</div><p>
<a class="anchor" name="bc1f33f288750dbd42074ba7861614c7"></a><!-- doxytag: member="Ogre::VertexDeclaration::getElement" ref="bc1f33f288750dbd42074ba7861614c7" args="(unsigned short index)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a>* Ogre::VertexDeclaration::getElement           </td>
          <td>(</td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>index</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get a single element. 
<p>

</div>
</div><p>
<a class="anchor" name="98cce285a45ba6f4cf817dcf46bfb588"></a><!-- doxytag: member="Ogre::VertexDeclaration::sort" ref="98cce285a45ba6f4cf817dcf46bfb588" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::VertexDeclaration::sort           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sorts the elements in this list to be compatible with the maximum number of rendering APIs / graphics cards. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Older graphics cards require vertex data to be presented in a more rigid way, as defined in the main documentation for this class. As well as the ordering being important, where shared source buffers are used, the declaration must list all the elements for each source in turn. </dd></dl>

</div>
</div><p>
<a class="anchor" name="260ecb704cfc32b82f248e382a53be47"></a><!-- doxytag: member="Ogre::VertexDeclaration::closeGapsInSource" ref="260ecb704cfc32b82f248e382a53be47" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::VertexDeclaration::closeGapsInSource           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Remove any gaps in the source buffer list used by this declaration. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This is useful if you've modified a declaration and want to remove any gaps in the list of buffers being used. Note, however, that if this declaration is already being used with a <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex...">VertexBufferBinding</a>, you will need to alter that too. This method is mainly useful when reorganising buffers based on an altered declaration. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This will cause the vertex declaration to be re-sorted. </dd></dl>

</div>
</div><p>
<a class="anchor" name="da106dad90a32452cead050b2f1f76aa"></a><!-- doxytag: member="Ogre::VertexDeclaration::getAutoOrganisedDeclaration" ref="da106dad90a32452cead050b2f1f76aa" args="(bool skeletalAnimation, bool vertexAnimation)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a>* Ogre::VertexDeclaration::getAutoOrganisedDeclaration           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>skeletalAnimation</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>vertexAnimation</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Generates a new <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to...">VertexDeclaration</a> for optimal usage based on the current vertex declaration, which can be used with <a class="el" href="classOgre_1_1VertexData.html#a5bf979b80f8bf95d76b7b8c34ac6fce" title="Reorganises the data in the vertex buffers according to the new vertex declaration...">VertexData::reorganiseBuffers</a> later if you wish, or simply used as a template. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Different buffer organisations and buffer usages will be returned depending on the parameters passed to this method. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>skeletalAnimation</em>&nbsp;</td><td>Whether this vertex data is going to be skeletally animated </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>vertexAnimation</em>&nbsp;</td><td>Whether this vertex data is going to be vertex animated </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="2aca53e4f9ccb1cef8d070b037e3b649"></a><!-- doxytag: member="Ogre::VertexDeclaration::getMaxSource" ref="2aca53e4f9ccb1cef8d070b037e3b649" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned short Ogre::VertexDeclaration::getMaxSource           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the indeex of the highest source value referenced by this declaration. 
<p>

</div>
</div><p>
<a class="anchor" name="e789acf4f4a63d8638fc23cb4e26239f"></a><!-- doxytag: member="Ogre::VertexDeclaration::addElement" ref="e789acf4f4a63d8638fc23cb4e26239f" args="(unsigned short source, size_t offset, VertexElementType theType, VertexElementSemantic semantic, unsigned short index=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a>&amp; Ogre::VertexDeclaration::addElement           </td>
          <td>(</td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>offset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#027109503a988ba85f4c63b55082907f">VertexElementType</a>&nbsp;</td>
          <td class="paramname"> <em>theType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&nbsp;</td>
          <td class="paramname"> <em>semantic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>index</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Adds a new <a class="el" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete...">VertexElement</a> to this declaration. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This method adds a single element (positions, normals etc) to the end of the vertex declaration. <b>Please read the information in <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to...">VertexDeclaration</a> about the importance of ordering and structure for compatibility with older D3D drivers</b>. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>source</em>&nbsp;</td><td>The binding index of <a class="el" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a> which will provide the source for this element. See VertexBufferBindingState for full information. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>offset</em>&nbsp;</td><td>The offset in bytes where this element is located in the buffer </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>theType</em>&nbsp;</td><td>The data format of the element (3 floats, a colour etc) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>semantic</em>&nbsp;</td><td>The meaning of the data (position, normal, diffuse colour etc) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>index</em>&nbsp;</td><td>Optional index for multi-input elements like texture coordinates </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>A reference to the <a class="el" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete...">VertexElement</a> added. </dd></dl>

</div>
</div><p>
<a class="anchor" name="b11e10c594cd765a0d8389b9e96ec24e"></a><!-- doxytag: member="Ogre::VertexDeclaration::insertElement" ref="b11e10c594cd765a0d8389b9e96ec24e" args="(unsigned short atPosition, unsigned short source, size_t offset, VertexElementType theType, VertexElementSemantic semantic, unsigned short index=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a>&amp; Ogre::VertexDeclaration::insertElement           </td>
          <td>(</td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>atPosition</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>offset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#027109503a988ba85f4c63b55082907f">VertexElementType</a>&nbsp;</td>
          <td class="paramname"> <em>theType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&nbsp;</td>
          <td class="paramname"> <em>semantic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>index</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Inserts a new <a class="el" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete...">VertexElement</a> at a given position in this declaration. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This method adds a single element (positions, normals etc) at a given position in this vertex declaration. <b>Please read the information in <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to...">VertexDeclaration</a> about the importance of ordering and structure for compatibility with older D3D drivers</b>. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>source</em>&nbsp;</td><td>The binding index of <a class="el" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a> which will provide the source for this element. See VertexBufferBindingState for full information. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>offset</em>&nbsp;</td><td>The offset in bytes where this element is located in the buffer </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>theType</em>&nbsp;</td><td>The data format of the element (3 floats, a colour etc) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>semantic</em>&nbsp;</td><td>The meaning of the data (position, normal, diffuse colour etc) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>index</em>&nbsp;</td><td>Optional index for multi-input elements like texture coordinates </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>A reference to the <a class="el" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete...">VertexElement</a> added. </dd></dl>

</div>
</div><p>
<a class="anchor" name="2dc6358fb76e454d7ae30da4d014687c"></a><!-- doxytag: member="Ogre::VertexDeclaration::removeElement" ref="2dc6358fb76e454d7ae30da4d014687c" args="(unsigned short elem_index)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::VertexDeclaration::removeElement           </td>
          <td>(</td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>elem_index</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Remove the element at the given index from this declaration. 
<p>

</div>
</div><p>
<a class="anchor" name="d98b8d55cf8490d788ba46633143ef94"></a><!-- doxytag: member="Ogre::VertexDeclaration::removeElement" ref="d98b8d55cf8490d788ba46633143ef94" args="(VertexElementSemantic semantic, unsigned short index=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::VertexDeclaration::removeElement           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&nbsp;</td>
          <td class="paramname"> <em>semantic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>index</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Remove the element with the given semantic and usage index. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>In this case 'index' means the usage index for repeating elements such as texture coordinates. For other elements this will always be 0 and does not refer to the index in the vector. </dd></dl>

</div>
</div><p>
<a class="anchor" name="9c6df3f800c43118c49e30940445669f"></a><!-- doxytag: member="Ogre::VertexDeclaration::removeAllElements" ref="9c6df3f800c43118c49e30940445669f" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::VertexDeclaration::removeAllElements           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Remove all elements. 
<p>

</div>
</div><p>
<a class="anchor" name="cf877a67096cf85fce47757010b531b1"></a><!-- doxytag: member="Ogre::VertexDeclaration::modifyElement" ref="cf877a67096cf85fce47757010b531b1" args="(unsigned short elem_index, unsigned short source, size_t offset, VertexElementType theType, VertexElementSemantic semantic, unsigned short index=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::VertexDeclaration::modifyElement           </td>
          <td>(</td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>elem_index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>offset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#027109503a988ba85f4c63b55082907f">VertexElementType</a>&nbsp;</td>
          <td class="paramname"> <em>theType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&nbsp;</td>
          <td class="paramname"> <em>semantic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>index</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Modify an element in-place, params as addElement. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd><b>Please read the information in <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to...">VertexDeclaration</a> about the importance of ordering and structure for compatibility with older D3D drivers</b>. </dd></dl>

</div>
</div><p>
<a class="anchor" name="dcc074b1bc6cdad3bde1d44c84ec6ccb"></a><!-- doxytag: member="Ogre::VertexDeclaration::findElementBySemantic" ref="dcc074b1bc6cdad3bde1d44c84ec6ccb" args="(VertexElementSemantic sem, unsigned short index=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a>* Ogre::VertexDeclaration::findElementBySemantic           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&nbsp;</td>
          <td class="paramname"> <em>sem</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>index</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Finds a <a class="el" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete...">VertexElement</a> with the given semantic, and index if there is more than one element with the same semantic. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>If the element is not found, this method returns null. </dd></dl>

</div>
</div><p>
<a class="anchor" name="8efa1381b62ed44af9e1e366938a455f"></a><!-- doxytag: member="Ogre::VertexDeclaration::findElementsBySource" ref="8efa1381b62ed44af9e1e366938a455f" args="(unsigned short source)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1VertexDeclaration.html#60080b97acb5b645bf3524152d75cc5d">VertexElementList</a> Ogre::VertexDeclaration::findElementsBySource           </td>
          <td>(</td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>source</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Based on the current elements, gets the size of the vertex for a given buffer source. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>source</em>&nbsp;</td><td>The buffer binding index for which to get the vertex size. Gets a list of elements which use a given source. </td></tr>
  </table>
</dl>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Note that the list of elements is returned by value therefore is separate from the declaration as soon as this method returns. </dd></dl>

</div>
</div><p>
<a class="anchor" name="383736c1eed33634e0eaa9910f0176af"></a><!-- doxytag: member="Ogre::VertexDeclaration::getVertexSize" ref="383736c1eed33634e0eaa9910f0176af" args="(unsigned short source)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual size_t Ogre::VertexDeclaration::getVertexSize           </td>
          <td>(</td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>source</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the vertex size defined by this declaration for a given source. 
<p>

</div>
</div><p>
<a class="anchor" name="933bb27a39695a561959638bfa82177c"></a><!-- doxytag: member="Ogre::VertexDeclaration::clone" ref="933bb27a39695a561959638bfa82177c" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a>* Ogre::VertexDeclaration::clone           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Clones this declaration. 
<p>

</div>
</div><p>
<a class="anchor" name="ee364dc39b2dfdbff4a5b135e5e5ef39"></a><!-- doxytag: member="Ogre::VertexDeclaration::operator==" ref="ee364dc39b2dfdbff4a5b135e5e5ef39" args="(const VertexDeclaration &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::VertexDeclaration::operator==           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rhs</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareVertexBuffer_8h-source.html#l00429">429</a> of file <a class="el" href="OgreHardwareVertexBuffer_8h-source.html">OgreHardwareVertexBuffer.h</a>.</p>

<p>References <a class="el" href="OgreHardwareVertexBuffer_8h-source.html#l00299">mElementList</a>.</p>

</div>
</div><p>
<a class="anchor" name="64989816c9979aac5a5416d488d547d5"></a><!-- doxytag: member="Ogre::VertexDeclaration::operator!=" ref="64989816c9979aac5a5416d488d547d5" args="(const VertexDeclaration &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::VertexDeclaration::operator!=           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rhs</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareVertexBuffer_8h-source.html#l00446">446</a> of file <a class="el" href="OgreHardwareVertexBuffer_8h-source.html">OgreHardwareVertexBuffer.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="dc48aa31318d2384866eab90ee8406d5"></a><!-- doxytag: member="Ogre::VertexDeclaration::mElementList" ref="dc48aa31318d2384866eab90ee8406d5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexDeclaration.html#60080b97acb5b645bf3524152d75cc5d">VertexElementList</a> <a class="el" href="classOgre_1_1VertexDeclaration.html#dc48aa31318d2384866eab90ee8406d5">Ogre::VertexDeclaration::mElementList</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareVertexBuffer_8h-source.html#l00299">299</a> of file <a class="el" href="OgreHardwareVertexBuffer_8h-source.html">OgreHardwareVertexBuffer.h</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareVertexBuffer_8h-source.html#l00429">operator==()</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreHardwareVertexBuffer_8h-source.html">OgreHardwareVertexBuffer.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:49:59 2008
</p>
</body>
</html>
